#include "studentdatabase.h"
#include "ui_studentdatabase.h"
#include <QDir>
#include<QMessageBox>
#include<QtSql/QSqlRecord>
#include<QtSql/QSqlQuery>

Studentdatabase::Studentdatabase(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::Studentdatabase)
{
    ui->setupUi(this);
    QString path;
    path="D:\TutorialCD\QT C++\StudentDatabase";
    QDir file;
    QString filename=file.path()+QDir::separator()+"student.db";
    if(!createDB(filename))
            {
                QMessageBox::critical(this,
                                      tr("Database not found"),
                                      tr("Database not found. The application will be closed."),
                                      QMessageBox::Ok);
                qApp->exit();
            }
}

Studentdatabase::~Studentdatabase()
{
    delete ui;
}
bool Studentdatabase::createDB(QString dbname)
{
    db = QSqlDatabase::addDatabase("QSQLITE");
           db.setDatabaseName(dbname);

           if(db.open())
           {

               bool found = false;
               foreach (QString table, db.tables())
               {
                   if(table == "student")
                   {
                       found = true;
                       break;
                   }
               }
               if(!found)
               {
                   QSqlQuery query(db);
                   query.exec("CREATE TABLE student (name VARCHAR(32), Roll_No VARCHAR(16))");
               }

               model = new QSqlTableModel(this,db);
               model->setTable("student");

               model->setEditStrategy(QSqlTableModel::OnFieldChange);
               model->select();


           }
           else
               return false;

           return true;
}

void  Studentdatabase::AddNewStudent(QString Name, QString Roll_No)
{
    QSqlRecord rec=model->record();
    rec.setValue("name",Name);
    rec.setValue("Roll_No",Roll_No);

    //insert a new record(-1)
    model->insertRecord(-1,rec);
    ui->textEditName->setText("");
    ui->textEditRoll_No->setText("");
}

void Studentdatabase::on_pushButtonAdd_clicked()
{
    QString Name=ui->textEditName->toPlainText();
    QString RollNo=ui->textEditRoll_No->toPlainText();
    AddNewStudent(Name,RollNo);
}

void Studentdatabase::on_pushButtonDelete_clicked()
{
    QModelIndex sample = ui->treeView->currentIndex();
            if( sample.row() >= 0 )
            {
                QMessageBox::StandardButton dlg;
                dlg = QMessageBox::question(this, tr("Remove Student"),
                                            QString(tr("Remove Student ?")),
                                            QMessageBox::Yes | QMessageBox::No);

                if(dlg == QMessageBox::Yes)
                {
                    // remove the current index
                    model->removeRow(sample.row());
                }
            }
}

void Studentdatabase::on_pushButtonView_clicked()
{
     QTreeView *view;
     view=ui->treeView;
     ViewDetails();
}
void Studentdatabase::ViewDetails()
{
    QTreeView *view=ui->treeView;
    view->setModel(model);

}
